import logo from './logo.svg';
import './App.css';
import React, { useEffect, useState } from 'react';


// SecondsTimer
const SecondsTimer = ({ seconds }) => <h2>{seconds}</h2>

// TimerContainer
const TimerContainer = ({ seconds, refresh, render }) => {
  console.log('seconds ', seconds)

  const [count, setCount] = useState(seconds) // отслеживаем состояние количества секунд
  const [isRunning, setIsRunning] = useState(false) // отслеживаем состояние кнопки стоп/старт для таймера
  const Render = render

  useEffect(() => { setCount(seconds) }, [seconds]) // синхронизируем count с передаваемыми seconds

  useEffect(() => { // эффект, отвечающий за то, когда счетчик прошле в 0, он его переводит в состояние паузы
    if (count === 0) {
      setIsRunning(false)
    }
  }, [count === 0])

  useEffect(() => { // сам счетчик
    if (isRunning) {
      const start = performance.now()

      const int = setInterval(() => {

        const diff = Math.floor((performance.now() - start) / refresh)
        setCount(count => count - diff)
      }, refresh)

      return () => clearInterval(int)
    }
  })

  return (
    <div>
      <Render seconds={count} />
      <button onClick={() => setIsRunning(!isRunning)}>{isRunning ? 'Pause' : 'Start'}</button>
    </div >
  )
}


// TimerControlTimerContainer
const TimerControlTimerContainer = () => {
  const [hours, setHours] = useState('')
  const [minutes, setMinutes] = useState('')
  const [seconds, setSeconds] = useState('')

  const ms = +hours * 60 * 60 + +minutes * 60 + +seconds

  return (
    <div>
      <h2>TimerControl + TimerContainer</h2>
      <br />
      <input type='number' min='0' max='23' placeholder='00' onChange={e => setHours(e.target.value)}></input>
      <input type='number' min='0' max='59' placeholder='00' onChange={e => setMinutes(e.target.value)}></input>
      <input type='number' min='0' max='59' placeholder='00' onChange={e => setSeconds(e.target.value)}></input>
      <br />
      {console.log('ms ', ms)}
      <TimerContainer seconds={ms} refresh={100} render={SecondsTimer} />
    </div >
  )
}

function App() {
  return (
    <div className="App">
      <header>

        <TimerControlTimerContainer />

      </header>
    </div>
  );
}

export default App;