import { useHistory } from 'react-router-dom'

import { Typography, Box } from '@mui/material'

function Page404() {

    const history = useHistory()

    function toMain() {
        history.push('/')
    }

    return (
        <Box
            sx={{
                marginTop: '20px',
                padding: '16px'
            }}
        >
            <Typography
                variant="h6"
                gutterBottom
                color='text.primary'
                align='center'
            >
                К сожалению, эта страница недоступна.
            </Typography>

            <Typography
                variant="subtitle1"
                gutterBottom
                color='text.primary'
                align='center'
            >
                Возможно, вы воспользовались недействительной ссылкой или страница была удалена.
            </Typography>

            <Typography
                variant="subtitle1"
                gutterBottom
                color='text.primary'
                align='center'
                onClick={toMain}
                sx={{
                    cursor: 'pointer'
                }}
            >
                Назад в Instagram.
            </Typography>
        </Box>
    )
}


export default Page404