import * as React from 'react';
import { useEffect } from 'react';
import { useParams } from 'react-router-dom';
import { connect } from 'react-redux';
import { store } from '../../redux';

import { Box, Container, Divider } from '@mui/material';

import BasicCard from './userData';
import { actionFindUserOne, actionFullUserFindOne } from '../../redux/thunks';

import { StandardImageList, СStandardImageList } from './gallery';

function User({ user = {}, loadUser }) {
    // console.log('user: ', user)

    const { userId } = useParams()
    useEffect(() => { loadUser(userId) }, [userId])

    return (
        <React.Fragment>
            <Box
                sx={{
                    margin: "20px 50px"
                }}
            >
                <BasicCard userData={user} />
            </Box>

            <Divider />

            <Box >
                <СStandardImageList />
            </Box>
        </React.Fragment >
    );
}

export const CUser = connect(state => ({ user: state?.promise?.UserFindOne?.payload }), { loadUser: actionFullUserFindOne })(User)





















// export const CUser = connect(state => ({ user: state?.promise?.UserFindOne?.payload }), { loadUser: actionFullUserFindOne })(User)

// export const CUser = connect(state => ({ user: state?.promise }), { loadUser: actionFullUserFindOne })(User)